package quimufu.colourful_portals.config;

import com.google.common.collect.Lists;
import eu.midnightdust.lib.config.MidnightConfig;
import net.minecraft.util.DyeColor;

import java.util.HashSet;
import java.util.List;
import java.util.Set;

public class ColourfulPortalConfig extends MidnightConfig {

    @Entry(category = "text", name = "Disable Immersive Portals integration")
    public static boolean disableImmersivePortals = false;

    @Comment(category = "text")
    public static Comment explanation;

    @Entry(category = "text", name = "Blocks that create white portals")
    public static List<String> white = Lists.newArrayList("minecraft:white_wool");

    @Entry(category = "text", name = "Blocks that create orange portals")
    public static List<String> orange = Lists.newArrayList("minecraft:orange_wool");

    @Entry(category = "text", name = "Blocks that create magenta portals")
    public static List<String> magenta = Lists.newArrayList("minecraft:magenta_wool");

    @Entry(category = "text", name = "Blocks that create light blue portals")
    public static List<String> light_blue = Lists.newArrayList("minecraft:light_blue_wool");

    @Entry(category = "text", name = "Blocks that create yellow portals")
    public static List<String> yellow = Lists.newArrayList("minecraft:yellow_wool");

    @Entry(category = "text", name = "Blocks that create lime portals")
    public static List<String> lime = Lists.newArrayList("minecraft:lime_wool");

    @Entry(category = "text", name = "Blocks that create pink portals")
    public static List<String> pink = Lists.newArrayList("minecraft:pink_wool");

    @Entry(category = "text", name = "Blocks that create gray portals")
    public static List<String> gray = Lists.newArrayList("minecraft:gray_wool");

    @Entry(category = "text", name = "Blocks that create light gray portals")
    public static List<String> light_gray = Lists.newArrayList("minecraft:light_gray_wool");

    @Entry(category = "text", name = "Blocks that create cyan portals")
    public static List<String> cyan = Lists.newArrayList("minecraft:cyan_wool");

    @Entry(category = "text", name = "Blocks that create purple portals")
    public static List<String> purple = Lists.newArrayList("minecraft:purple_wool");

    @Entry(category = "text", name = "Blocks that create blue portals")
    public static List<String> blue = Lists.newArrayList("minecraft:blue_wool");

    @Entry(category = "text", name = "Blocks that create brown portals")
    public static List<String> brown = Lists.newArrayList("minecraft:brown_wool");

    @Entry(category = "text", name = "Blocks that create green portals")
    public static List<String> green = Lists.newArrayList("minecraft:green_wool");

    @Entry(category = "text", name = "Blocks that create red portals")
    public static List<String> red = Lists.newArrayList("minecraft:red_wool");

    @Entry(category = "text", name = "Blocks that create black portals")
    public static List<String> black = Lists.newArrayList("minecraft:black_wool");

    //todo: disabled until i find a good solution
    //@Entry(category = "text", name = "Blocks that create fully transparent portals")
    public static List<String> none = Lists.newArrayList();

    public static Set<String> getAllPortalBlocks() {
        Set<String> allBlocks = new HashSet<>();
        allBlocks.addAll(white);
        allBlocks.addAll(orange);
        allBlocks.addAll(magenta);
        allBlocks.addAll(light_blue);
        allBlocks.addAll(yellow);
        allBlocks.addAll(lime);
        allBlocks.addAll(pink);
        allBlocks.addAll(gray);
        allBlocks.addAll(light_gray);
        allBlocks.addAll(cyan);
        allBlocks.addAll(purple);
        allBlocks.addAll(blue);
        allBlocks.addAll(brown);
        allBlocks.addAll(green);
        allBlocks.addAll(red);
        allBlocks.addAll(black);
        allBlocks.addAll(none);
        return allBlocks;
    }

    public static DyeColor colorOf(String block) {
        if (white.contains(block)) {
            return DyeColor.WHITE;
        } else if (orange.contains(block)) {
            return DyeColor.ORANGE;
        } else if (magenta.contains(block)) {
            return DyeColor.MAGENTA;
        } else if (light_blue.contains(block)) {
            return DyeColor.LIGHT_BLUE;
        } else if (yellow.contains(block)) {
            return DyeColor.YELLOW;
        } else if (lime.contains(block)) {
            return DyeColor.LIME;
        } else if (pink.contains(block)) {
            return DyeColor.PINK;
        } else if (gray.contains(block)) {
            return DyeColor.GRAY;
        } else if (light_gray.contains(block)) {
            return DyeColor.LIGHT_GRAY;
        } else if (cyan.contains(block)) {
            return DyeColor.CYAN;
        } else if (purple.contains(block)) {
            return DyeColor.PURPLE;
        } else if (blue.contains(block)) {
            return DyeColor.BLUE;
        } else if (brown.contains(block)) {
            return DyeColor.BROWN;
        } else if (green.contains(block)) {
            return DyeColor.GREEN;
        } else if (red.contains(block)) {
            return DyeColor.RED;
        } else if (black.contains(block)) {
            return DyeColor.BLACK;
        } else if (none.contains(block)) {
            return null; // Fully transparent portal
        } else {
            throw new IllegalArgumentException("Invalid portal block: " + block);
        }
    }
}
