package quimufu.colourful_portals.mixin.client;

import net.minecraft.client.texture.Animator;
import net.minecraft.client.texture.SpriteContents;
import org.spongepowered.asm.mixin.Final;
import org.spongepowered.asm.mixin.Mixin;
import org.spongepowered.asm.mixin.Shadow;
import org.spongepowered.asm.mixin.Unique;
import org.spongepowered.asm.mixin.injection.At;
import org.spongepowered.asm.mixin.injection.Inject;
import org.spongepowered.asm.mixin.injection.callback.CallbackInfo;
import org.spongepowered.asm.mixin.injection.callback.CallbackInfoReturnable;
import quimufu.colourful_portals.client.AlphaBlendingAnimator;
import quimufu.colourful_portals.client.AlphaInterpolationHolder;

import java.util.List;

@Mixin(SpriteContents.Animation.class)
public class AnimationMixin implements AlphaInterpolationHolder {
    @Shadow
    @Final
    private boolean interpolation;

    @Unique
    private SpriteContents parent;

    @Unique
    private boolean interpolateAlpha = false;

    @Inject(method = "<init>", at = @At("RETURN"))
    public void assignParent(SpriteContents parent, List frames, int frameCount, boolean interpolation, CallbackInfo ci) {
        this.parent = parent;
    }

    public void colourful_portals$setInterpolateAlpha(boolean interpolateAlpha) {
        this.interpolateAlpha = interpolateAlpha;
    }

    public boolean colourful_portals$isInterpolateAlpha() {
        return interpolateAlpha;
    }

    @Inject(at = @At("RETURN"), method = "createAnimator()Lnet/minecraft/client/texture/Animator;", cancellable = true)
    public void createAnimator(CallbackInfoReturnable<Animator> cir) {
        if (this.interpolateAlpha && this.interpolation) {
            cir.setReturnValue(new AlphaBlendingAnimator(parent, (SpriteContents.Animation) (Object) this));
            cir.cancel();
        }
    }
}
