package quimufu.colourful_portals.mixin.client;

import me.jellysquid.mods.sodium.client.render.chunk.compile.ChunkBuildBuffers;
import me.jellysquid.mods.sodium.client.render.chunk.compile.pipeline.FluidRenderer;
import me.jellysquid.mods.sodium.client.world.WorldSlice;
import net.minecraft.fluid.FluidState;
import net.minecraft.util.math.BlockPos;
import org.spongepowered.asm.mixin.Mixin;
import org.spongepowered.asm.mixin.injection.At;
import org.spongepowered.asm.mixin.injection.Inject;
import org.spongepowered.asm.mixin.injection.callback.CallbackInfo;
import quimufu.colourful_portals.client.SodiumPortalFluidRenderHandler;

import static quimufu.colourful_portals.ColourfulPortalsMod.PORTAL_FLUID;

@Mixin(FluidRenderer.class)
public class SodiumFluidRendererMixin {

    private final SodiumPortalFluidRenderHandler sodiumPortalFluidRenderHandler = new SodiumPortalFluidRenderHandler();

    @Inject(at = @At("HEAD"), method = "render", cancellable = true, remap = false)
    private void init(WorldSlice world, FluidState fluidState, BlockPos blockPos, BlockPos offset, ChunkBuildBuffers buffers, CallbackInfo ci) {
        if (fluidState.isOf(PORTAL_FLUID)) {
            sodiumPortalFluidRenderHandler.render(world, fluidState, blockPos, offset, buffers);
            ci.cancel();
        }
    }
}
